/* granite.vapi generated by valac 0.16.0, do not modify. */

namespace Granite {
	namespace Drawing {
		[CCode (cheader_filename = "granite.h")]
		public class Color : GLib.Object, Granite.Services.SettingsSerializable {
			public double R;
			public double G;
			public double B;
			public double A;
			public Color (double R, double G, double B, double A);
			public Color.from_gdk (Gdk.Color color);
			public Granite.Drawing.Color set_hue (double hue);
			public Granite.Drawing.Color set_sat (double sat);
			public Granite.Drawing.Color set_val (double val);
			public Granite.Drawing.Color set_alpha (double alpha);
			public double get_hue ();
			public double get_sat ();
			public double get_val ();
			public Granite.Drawing.Color add_hue (double val);
			public Granite.Drawing.Color set_min_sat (double sat);
			public Granite.Drawing.Color set_min_value (double val);
			public Granite.Drawing.Color set_max_sat (double sat);
			public Granite.Drawing.Color set_max_val (double val);
			public Granite.Drawing.Color multiply_sat (double amount);
			public Granite.Drawing.Color brighten_val (double amount);
			public Granite.Drawing.Color darken_val (double amount);
			public Granite.Drawing.Color darken_by_sat (double amount);
		}
		[CCode (cheader_filename = "granite.h")]
		public class BufferSurface : GLib.Object {
			public BufferSurface (int width, int height);
			public BufferSurface.with_surface (int width, int height, Cairo.Surface model);
			public BufferSurface.with_buffer_surface (int width, int height, Granite.Drawing.BufferSurface model);
			public void clear ();
			public Gdk.Pixbuf load_to_pixbuf ();
			public Granite.Drawing.Color average_color ();
			public void fast_blur (int radius, int process_count = 1);
			public void exponential_blur (int radius);
			public void gaussian_blur (int radius);
			public Cairo.Surface surface { get; private set; }
			public int width { get; private set; }
			public int height { get; private set; }
			public Cairo.Context context { get; }
		}
		[CCode (cheader_filename = "granite.h")]
		public class Utilities : GLib.Object {
			public static void cairo_rounded_rectangle (Cairo.Context cr, double x, double y, double width, double height, double radius);
			public static Granite.Drawing.Color average_color (Gdk.Pixbuf source);
			public Utilities ();
		}
	}
	namespace GtkPatch {
		[CCode (cheader_filename = "granite.h")]
		public class AboutDialog : Gtk.Dialog {
			public AboutDialog ();
			public string[] artists { get; set; }
			public string[] authors { get; set; }
			public string comments { get; set; }
			public string copyright { get; set; }
			public string[] documenters { get; set; }
			public string license { get; set; }
			public Gtk.License license_type { get; set; }
			public Gdk.Pixbuf logo { get; set; }
			public string logo_icon_name { get; set; }
			public string program_name { get; set; }
			public string translator_credits { get; set; }
			public string version { get; set; }
			public string website { get; set; }
			public string website_label { get; set; }
			public virtual signal bool activate_link (string uri);
		}
	}
	namespace Services {
		[CCode (cheader_filename = "granite.h")]
		public abstract class Settings : GLib.Object {
			public Settings (string schema);
			public Settings.with_backend (string schema, GLib.SettingsBackend backend);
			public Settings.with_backend_and_path (string schema, GLib.SettingsBackend backend, string path);
			public Settings.with_path (string schema, string path);
			protected virtual void verify (string key);
			public GLib.Settings schema { get; construct; }
			[Signal (action = true, detailed = true, no_hooks = true, no_recurse = true, run = "first")]
			public signal void changed ();
		}
		[CCode (cheader_filename = "granite.h")]
		public class Logger : GLib.Object {
			public static void initialize (string app_name);
			public static void notification (string msg);
			public Logger ();
			public static Granite.Services.LogLevel DisplayLevel { get; set; }
		}
		[CCode (cheader_filename = "granite.h")]
		public class Paths : GLib.Object {
			public static void initialize (string app_name, string data_folder_path);
			public static bool ensure_directory_exists (GLib.File dir);
			public Paths ();
			public static GLib.File home_folder { get; protected set; }
			public static GLib.File data_folder { get; protected set; }
			public static GLib.File xdg_config_home_folder { get; protected set; }
			public static GLib.File xdg_data_home_folder { get; protected set; }
			public static GLib.File xdg_cache_home_folder { get; protected set; }
			public static GLib.List<GLib.File> xdg_data_dir_folders { get; protected owned set; }
			public static GLib.File user_config_folder { get; protected set; }
			public static GLib.File user_data_folder { get; protected set; }
			public static GLib.File user_cache_folder { get; protected set; }
		}
		[CCode (cheader_filename = "granite.h")]
		public class System : GLib.Object {
			public static void open_uri (string uri);
			public static void open (GLib.File file);
			public static void open_files (GLib.File[] files);
			public static void launch (GLib.File app);
			public static bool execute_command (string command);
			public static void launch_with_files (GLib.File? app, GLib.File[] files);
			public System ();
		}
		[CCode (cheader_filename = "granite.h")]
		public class Contractor : GLib.Object {
			internal Granite.Services.ContractorDBus contract;
			internal static Granite.Services.Contractor? contractor;
			public Contractor ();
			internal static void ensure ();
			public static GLib.HashTable<string,string>[] get_contract (string uri, string mime);
			public static GLib.HashTable<string,string>[] get_selection_contracts (GLib.HashTable<string,string>[] locations);
		}
		[CCode (cheader_filename = "granite.h")]
		public interface SettingsSerializable : GLib.Object {
			public abstract string settings_serialize ();
			public abstract void settings_deserialize (string s);
		}
		[CCode (cheader_filename = "granite.h")]
		[DBus (name = "org.elementary.contractor")]
		internal interface ContractorDBus : GLib.Object {
			public abstract GLib.HashTable<string,string>[] GetServicesByLocation (string strlocation, string? file_mime = "") throws GLib.IOError;
			public abstract GLib.HashTable<string,string>[] GetServicesByLocationsList (GLib.HashTable<string,string>[] locations) throws GLib.IOError;
		}
		[CCode (cheader_filename = "granite.h")]
		public enum LogLevel {
			DEBUG,
			INFO,
			NOTIFY,
			WARN,
			ERROR,
			FATAL
		}
		[CCode (cheader_filename = "granite.h")]
		internal enum ConsoleColor {
			BLACK,
			RED,
			GREEN,
			YELLOW,
			BLUE,
			MAGENTA,
			CYAN,
			WHITE
		}
	}
	namespace Widgets {
		[CCode (cheader_filename = "granite.h")]
		public class WrapLabel : Gtk.Label {
			public int m_wrap_width;
			public int m_wrap_height;
			public WrapLabel (string? str = null);
			public override void get_preferred_width (out int minimum_width, out int natural_width);
			public override void size_allocate (Gtk.Allocation alloc);
		}
		[CCode (cheader_filename = "granite.h")]
		public class AboutDialog : Granite.GtkPatch.AboutDialog {
			public AboutDialog ();
			public string help { get; set; }
			public string translate { get; set; }
			public string bug { get; set; }
		}
		[CCode (cheader_filename = "granite.h")]
		public class ModeButton : Gtk.Box {
			internal static Gtk.CssProvider style_provider;
			internal static Gtk.StyleContext widget_style;
			public ModeButton ();
			public int append_pixbuf (Gdk.Pixbuf? pixbuf);
			public int append_text (string? text);
			public int append_icon (string icon_name, Gtk.IconSize size);
			public int append (Gtk.Widget w);
			public void set_active (int new_active_index);
			public void set_item_visible (int index, bool val);
			public new void remove (int index);
			public void clear_children ();
			protected override bool scroll_event (Gdk.EventScroll ev);
			public int selected { get; set; }
			public uint n_items { get; }
			public signal void mode_added (int index, Gtk.Widget widget);
			public signal void mode_removed (int index, Gtk.Widget widget);
			public signal void mode_changed (Gtk.Widget widget);
		}
		[CCode (cheader_filename = "granite.h")]
		internal class ModeButtonItem : Gtk.ToggleButton {
			public ModeButtonItem ();
		}
		[CCode (cheader_filename = "granite.h")]
		public class DatePicker : Gtk.Entry, Gtk.Buildable {
			protected Gtk.EventBox dropdown;
			protected Gtk.Calendar calendar;
			public DatePicker.with_format (string format);
			protected virtual void position_dropdown (out int x, out int y);
			public DatePicker ();
			public string format { get; construct; }
			public GLib.DateTime date { get; set; }
		}
		[CCode (cheader_filename = "granite.h")]
		public class HintedEntry : Gtk.Entry {
			public HintedEntry (string hint_string);
			protected void hint ();
			protected void unhint ();
			public new string get_text ();
			public new void set_text (string text);
			public string hint_string { get; set; }
		}
		[CCode (cheader_filename = "granite.h")]
		public class SearchBar : Granite.Widgets.HintedEntry {
			public SearchBar (string hint_string);
			protected new void hint ();
			public int pause_delay { get; set; }
			public signal void text_changed_pause (string text);
		}
		[CCode (cheader_filename = "granite.h")]
		public class TimePicker : Gtk.SpinButton, Gtk.Buildable {
			public TimePicker.with_format (string format);
			protected override bool output ();
			protected virtual void set_minutes (int minutes);
			public TimePicker ();
			public string format { get; construct; }
			public GLib.DateTime time { get; protected set; }
		}
		[CCode (cheader_filename = "granite.h")]
		public class CollapsiblePaned : Gtk.HPaned {
			public Granite.CollapseMode collapse_mode;
			public CollapsiblePaned (Gtk.Orientation o);
		}
		[CCode (cheader_filename = "granite.h")]
		public class HCollapsablePaned : Granite.Widgets.CollapsiblePaned {
			public HCollapsablePaned ();
		}
		[CCode (cheader_filename = "granite.h")]
		public class VCollapsablePaned : Granite.Widgets.CollapsiblePaned {
			public VCollapsablePaned ();
		}
		[CCode (cheader_filename = "granite.h")]
		public class StaticNotebook : Gtk.Box {
			public StaticNotebook ();
			public void set_switcher_visible (bool val);
			public void append_page (Gtk.Widget widget, Gtk.Label label);
			public void remove_page (int number);
			public int page { get; set; }
			public signal void page_changed (int index);
		}
		[CCode (cheader_filename = "granite.h")]
		public class CompositedWindow : Gtk.Window, Gtk.Buildable {
			public CompositedWindow ();
		}
		[CCode (cheader_filename = "granite.h")]
		public class AppMenu : Granite.Widgets.ToolButtonWithMenu {
			public Gtk.MenuItem about_item;
			public AppMenu (Gtk.Menu menu);
			public AppMenu.with_app (Granite.Application? application, Gtk.Menu menu);
			public AppMenu.with_urls (Gtk.Menu menu, string help_url, string translate_url, string bug_url);
			public void add_items (Gtk.Menu menu);
			public signal void show_about (Gtk.Widget w);
		}
		[CCode (cheader_filename = "granite.h")]
		public class Welcome : Gtk.EventBox {
			protected GLib.List<Gtk.Button> children;
			protected Gtk.Box options;
			public Welcome (string title_text, string subtitle_text);
			public void set_item_visible (uint index, bool val);
			public void remove_item (uint index);
			public void set_item_sensitivity (uint index, bool val);
			public int append (string icon_name, string option_text, string description_text);
			public int append_with_pixbuf (Gdk.Pixbuf? pixbuf, string option_text, string description_text);
			public int append_with_image (Gtk.Image? image, string option_text, string description_text);
			public signal void activated (int index);
		}
		[CCode (cheader_filename = "granite.h")]
		public class ToolButtonWithMenu : Gtk.ToggleToolButton {
			public enum MenuPosition {
				CENTER,
				LEFT,
				RIGHT,
				INSIDE_WINDOW
			}
			public delegate Gtk.Menu MenuFetcher ();
			public Gtk.Action? myaction;
			public ulong toggled_sig_id;
			public Granite.Widgets.ToolButtonWithMenu.MenuPosition menu_position;
			public ToolButtonWithMenu.from_action (Gtk.Action action);
			public ToolButtonWithMenu.from_stock (string stock_image, Gtk.IconSize size, string label, Gtk.Menu menu);
			public ToolButtonWithMenu (Gtk.Image image, string label, Gtk.Menu _menu, Granite.Widgets.ToolButtonWithMenu.MenuPosition menu_position = MenuPosition.CENTER);
			public override void show_all ();
			protected new void popup_menu (Gdk.EventButton? ev = null);
			protected void popdown_menu ();
			public Granite.Widgets.ToolButtonWithMenu.MenuFetcher fetcher { get; set; }
			public Gtk.Menu menu { get; set; }
			public signal void right_click (Gdk.EventButton ev);
		}
		[CCode (cheader_filename = "granite.h")]
		public class PopOver : Gtk.Dialog {
			public enum PopPosition {
				TOPLEFT,
				TOPRIGHT,
				BOTTOMLEFT,
				BOTTOMRIGHT
			}
			protected int BORDER_RADIUS;
			protected int BORDER_WIDTH;
			protected int SHADOW_SIZE;
			protected int ARROW_HEIGHT;
			protected int ARROW_WIDTH;
			protected Gtk.Border PADDINGS;
			protected bool arrow_up;
			protected double arrow_offset;
			protected Granite.Drawing.BufferSurface? main_buffer;
			public PopOver ();
			protected void reset_buffers ();
			public void set_parent_pop (Gtk.Window win);
			public void move_to_widget (Gtk.Widget w);
			public void move_to_coords (int x, int y);
			public void move_to_rect (Gdk.Rectangle rect);
			public void move_to_window (Gdk.Window window);
			protected void cairo_popover (Cairo.Context cr, double x, double y, double width, double height);
			public override bool draw (Cairo.Context cr);
		}
		[CCode (cheader_filename = "granite.h")]
		public class ContractorView : Gtk.TreeView {
			public delegate void ContractCallback ();
			public bool contractor_available;
			public ContractorView (string filename, string mime, int icon_size = 32, bool show_contract_name = true);
			public void add_item (string name, string desc, string icon_name, int icon_size, int position, Granite.Widgets.ContractorView.ContractCallback method);
			public void name_blacklist (string[] names);
			public void run_selected ();
			public int selected { get; set; }
		}
		[CCode (cheader_filename = "granite.h")]
		public extern static void show_about_dialog (Gtk.Window* parent, ...);
	}
	[CCode (cheader_filename = "granite.h")]
	public abstract class Application : Gtk.Application {
		public string build_data_dir;
		public string build_pkg_data_dir;
		public string build_release_name;
		public string build_version;
		public string build_version_info;
		public string program_name;
		public string exec_name;
		public string app_copyright;
		public string app_years;
		public string app_icon;
		public string app_launcher;
		public string main_url;
		public string bug_url;
		public string help_url;
		public string translate_url;
		public string[] about_authors;
		public string[] about_documenters;
		public string[] about_artists;
		public string about_comments;
		public string about_translators;
		public string about_license;
		public Gtk.License about_license_type;
		protected static bool DEBUG;
		protected Granite.Widgets.AboutDialog about_dlg;
		protected const GLib.OptionEntry[] options;
		public Application ();
		[CCode (cheader_filename = "sys/prctl.h", cname = "prctl")]
		protected extern static int prctl (int option, string arg2, ulong arg3, ulong arg4, ulong arg5);
		public new int run (string[] args);
		protected static void sig_handler (int sig);
		protected virtual void set_options ();
		public Granite.Widgets.AppMenu create_appmenu (Gtk.Menu menu);
		public virtual void show_about (Gtk.Widget parent);
	}
	[CCode (cheader_filename = "granite.h")]
	public enum CollapseMode {
		NONE,
		LEFT,
		TOP,
		FIRST,
		RIGHT,
		BOTTOM,
		LAST
	}
	[CCode (cheader_filename = "granite.h")]
	public static Granite.Application app;
	[CCode (cheader_filename = "granite.h")]
	public static void init ();
}
